#!/local/bin/jperl
# *****************************************************************************
# *                                                                           *
# *  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1995  *
# *                                                                           *
# *****************************************************************************
#
# ԣ·μ°̾դɽե륿
#


# ܥ
push(@INC,"./TABLES") ;
require 'E_POSN.pl' ;
require 'E_FUNCPOSI.pl' ;
require 'E_FUNCWD.pl' ;
require 'E_GRAMATTR.pl' ;
require 'E_LCON.pl' ;
require 'E_RCON.pl' ;
require 'E_STYLE.pl' ;
require 'E_USAGE.pl' ;
require 'E_WFORM.pl' ;
require 'J_POSN.pl' ;
require 'J_ASPE.pl' ;
require 'J_CONJ.pl' ;
require 'J_FUNC.pl' ;
require 'J_LCON.pl' ;
require 'J_RCON.pl' ;
require 'J_SURF.pl' ;
require 'J_USAGE.pl' ;
require 'JE.pl' ;
require 'ATTR.pl' ;
require 'FNAME.pl' ;



#ܥơ֥
#            ˥쥳ֹꤹ
sub main'syminit {
    local($recid) = @_ ;
    print ("---------------------------------------------------------------------------------------------\n") ;
    @symtbl = () ;
    @lcontbl = ();
    @rcontbl = ();

    $vlang = $ENV{'VLANG'} ;
    if ($vlang eq "") {
        $vlang = "J" ;
    }
    $record_number = $recid ;
}

#ܥơ֥ɽ
sub main'symprint {
    if ($#symtbl >= 0 || $#lcontbl >= 0 || $#rcontbl >= 0) {
        print (" . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . \n") ;
        do main'print_symtbl() ;
        print ("\n") ;
    }
}


#ϥȥ
sub main'dicprint {
    local(@fi) = @_ ;
    do main'syminit($fi[0]) ;
    if ( $fi[0] =~ /^JWD/ || $fi[0] =~ /^TJWD/ ) {
        do main'jwdprint(@fi) ;              #ܸñϡʴѸ
    }
    elsif ( $fi[0] =~ /^EWD/ || $fi[0] =~ /^TEWD/ ) {
        do main'ewdprint(@fi) ;              #ѸñϡʴѸ
    }
    elsif ( $fi[0] =~ /^EJB/ || $fi[0] =~ /^TEJB/ ||
            $fi[0] =~ /^JEB/ || $fi[0] =~ /^TJEB/ ) {
        do main'jebprint(@fi) ;              #ϡʴѸ
    }
    elsif ( $fi[0] =~ /^JCC/ || $fi[0] =~ /^ECC/ ) {
        do main'jccprint(@fi) ;              #
    }
    elsif ( $fi[0] =~ /^JCP/ ) {
        do main'jccptprint(@fi) ;            #ܸư춦ѥ
    }
    elsif ( $fi[0] =~ /^TJCC/ || $fi[0] =~ /^TECC/ ) {
        do main'tjccprint(@fi) ;             #Ѹ춦
    }
    elsif ( $fi[0] =~ /^JCO/ || $fi[0] =~ /^ECO/ ) {
        do main'jcorpprint(@fi) ;            #ѥ
    }
    elsif ( $fi[0] =~ /^CPC/ ||  $fi[0] =~ /^TCPC/ ) {
        do main'cpcprint(@fi) ;              #ǰηϼ
    }
    elsif ( $fi[0] =~ /^CPH/ ||  $fi[0] =~ /^TCPH/ ) {
        do main'cphprint(@fi) ;              #ǰФ
    }
    elsif ( $fi[0] =~ /^CPT/ ) {
        do main'cptprint(@fi) ;              #ǰҼ
    }
    do main'symprint() ;
}


#ܸ켭ϴؿ
sub main'jwdprint {
    local(@in) = @_ ;
    # ٥,Х塼,ե̾¸ߥե饰
    @fname = (0,1, "쥳ֹ",
              0,0, "Ф",
              1,1, "ñ츫Ф",
              1,1, "Ѳ-Ϣ°",
              1,1, "ɽ",
              1,1, "ȯ",
              0,0, "ʸˡ",
              1,1, "ʻ",
              1,1, "ʸ",
              1,1, "Ѿ",
              1,1, "ɽسʾ",
              1,1, "",
              1,1, "ǽ",
              0,0, "̣",
              1,1, "ǰ̻",
              1,0, "ǰФ",
              2,1, "Ѹ쳵ǰФ",
              2,1, "ܸ쳵ǰФ",
              1,0, "ǰ",
              2,1, "Ѹ쳵ǰ",
              2,1, "ܸ쳵ǰ",
              0,0, "ѡ¾",
              1,1, "ˡ",
              1,1, "",
              0,0, "",
              1,1, "") ;

    foreach $val (@in) {
        $ex = 0 ;
        while($ex == 0 && $#fname >= 0 ) {
            $lev = shift(@fname) ;
            $ex  = shift(@fname) ;
            $fn  = shift(@fname) ;
            if ($ex == 0) {
                do printfv($lev,$fn,"") ;
            }
        }
        if ($val ne "\"\"") {
            do printfv($lev,$fn,$val) ;
            if ($fn eq "Ѳ-Ϣ°") {
               do pick_con($val) ;
            }
            elsif ($fn eq "ʻ" || 
                   $fn eq "Ѿ" ||
                   $fn eq "ɽسʾ" ||
                   $fn eq "" ||
                   $fn eq "ǽ" ||
                   $fn eq "ˡ" ) {
               do pick_grm($val) ;
            }
        }
        
    }
    printf("\n") ;
}


# Ѥ³ϿʺǸξܺѡ
sub main'pick_con {
    local($_) = @_ ;
    local(@fv) ;
    local($cc,$s1,$s2) ;
    local($left,$right) ;
    @fv = split(/\(/) ;
    for ($cc=0 ; $cc <= $#fv ; $cc++) {
        $s1 = index(@fv[$cc],",",0) ;
        $s2 = index(@fv[$cc],")",0) ;
        if ($s1 < 0 || $s2 < 0) {
           next ;
        }
        $left = substr(@fv[$cc],0,$s1) ;
        $right=  substr(@fv[$cc],$s1+1,$s2-$s1-1) ;
        #print ("LEFT---->[$left]\n");
        #print ("RIGHT--->[$right]  TABLE[$J_rcon{$right}]\n");
        #print ("record_number---[$record_number]\n") ;
        if ( $record_number =~ /^JWD/ || $record_number =~ /^TJWD/ ) {
            if ($J_lcon{$left}  ne "") {
                push(@lcontbl,"LCONN") ;
                push(@lcontbl,$left) ;
                push(@lcontbl,$J_lcon{$left}) ;
            }
            if ($J_rcon{$right} ne "") {
                push(@rcontbl,"RCONN") ;
                push(@rcontbl,$right) ;
                push(@rcontbl,$J_rcon{$right}) ;
            }
        }
        else {
            if ($E_lcon{$left} ne "") {
                push(@lcontbl,"LCONN") ;
                push(@lcontbl,$left) ;
                push(@lcontbl,$E_lcon{$left}) ;
            }
            if ($E_rcon{$right} ne "") {
                push(@rcontbl,"RCONN") ;
                push(@rcontbl,$right) ;
                push(@rcontbl,$E_rcon{$right}) ;
            }
        }
    }
}



# ѤʸˡϿʺǸξܺѡ
sub main'pick_grm {
    local($_) = @_ ;
    local(@fv) ;
    local($cc,$s1,$s2) ;
    local($left,$right) ;
    @fv = split(/;/) ;
    for ($cc=0 ; $cc <= $#fv ; $cc++) {
        if ( $record_number =~ /^JWD/ || $record_number =~ /^TJWD/ ||
             $record_number =~ /^JEB/ || $record_number =~ /^TJEB/ ) {
            if ($J_POS{$fv[$cc]}  ne "") {
                push(@symtbl,"POS") ;
                push(@symtbl,$fv[$cc]) ;
                push(@symtbl,$J_POS{$fv[$cc]}) ;
            }
            elsif ($J_aspect{$fv[$cc]} ne "") {
                push(@symtbl,"ASP") ;
                push(@symtbl,$fv[$cc]) ;
                push(@symtbl,$J_aspect{$fv[$cc]}) ;
            }
            elsif ($J_conjugations{$fv[$cc]} ne "") {
                push(@symtbl,"CONJ") ;
                push(@symtbl,$fv[$cc]) ;
                push(@symtbl,$J_conjugations{$fv[$cc]}) ;
            }
            elsif ($J_funcword{$fv[$cc]} ne "") {
                push(@symtbl,"FUNC") ;
                push(@symtbl,$fv[$cc]) ;
                push(@symtbl,$J_funcword{$fv[$cc]}) ;
            }
            elsif ($J_surface{$fv[$cc]} ne "") {
                push(@symtbl,"SURF") ;
                push(@symtbl,$fv[$cc]) ;
                push(@symtbl,$J_surface{$fv[$cc]}) ;
            }
            elsif ($J_usage{$fv[$cc]} ne "") {
                push(@symtbl,"USAG") ;
                push(@symtbl,$fv[$cc]) ;
                push(@symtbl,$J_usage{$fv[$cc]}) ;
            }
        }
        else {
            if ($E_POS{$fv[$cc]}  ne "") {
                push(@symtbl,"POS") ;
                push(@symtbl,$fv[$cc]) ;
                push(@symtbl,$E_POS{$fv[$cc]}) ;
            }
            elsif ($EfuncPosi{$fv[$cc]} ne "") {
                push(@symtbl,"POSI") ;
                push(@symtbl,$fv[$cc]) ;
                push(@symtbl,$EfuncPosi{$fv[$cc]}) ;
            }
            elsif ($EfuncWord{$fv[$cc]} ne "") {
                push(@symtbl,"FUNC") ;
                push(@symtbl,$fv[$cc]) ;
                push(@symtbl,$EfuncWord{$fv[$cc]}) ;
            }
            elsif ($EGramAttr{$fv[$cc]} ne "") {
                push(@symtbl,"GRAM") ;
                push(@symtbl,$fv[$cc]) ;
                push(@symtbl,$EGramAttr{$fv[$cc]}) ;
            }
            elsif ($E_style{$fv[$cc]} ne "") {
                push(@symtbl,"STYL") ;
                push(@symtbl,$fv[$cc]) ;
                push(@symtbl,$E_style{$fv[$cc]}) ;
            }
            elsif ($E_usage{$fv[$cc]} ne "") {
                push(@symtbl,"USAG") ;
                push(@symtbl,$fv[$cc]) ;
                push(@symtbl,$E_usage{$fv[$cc]}) ;
            }
            elsif ($E_wform{$fv[$cc]} ne "") {
                push(@symtbl,"WFORM") ;
                push(@symtbl,$fv[$cc]) ;
                push(@symtbl,$E_wform{$fv[$cc]}) ;
            }

        }
    }

}


# ѤʻϿʺǸξܺѡ
sub main'pick_tran {
    local($_) = @_ ;
    local(@fv) ;
    local($cc,$s1,$s2) ;
    local($left,$right) ;
    @fv = split(/;/) ;
    for ($cc=0 ; $cc <= $#fv ; $cc++) {
        if ($JE_EPOS{$fv[$cc]}  ne "") {
            push(@symtbl,"TRAN") ;
            push(@symtbl,$fv[$cc]) ;
            push(@symtbl,$JE_EPOS{$fv[$cc]}) ;
        }
    }
}



#ǾեåȤϡ
sub main'little1 {
   local(@in) = @_ ;
   local($ret,$ct) ;

   $ret = -1 ;
   for ($ct=0 ; $ct <= $#in ; $ct++) {
       if ($in[$ct] < 0) {
           next ;
       }
       if ($ret < 0) {
           $ret = $in[$ct] ;
           next ;
       }
       if ($ret > $in[$ct]) {
           $ret = $in[$ct] ;
       }
   }
   return $ret ;
}



# Х塼ŬĹʬ䤹롣
sub main'split_val {
    local($limit,$val) = @_ ;
    local($xx,$s1,$s2,$len) ;
    @subs = () ;

    if (length($val) <= $limit) {
        push(@subs,$val) ;
        return ;
    }
    if ($val =~ "/" || $val =~ " " || $val =~ ",") {
        $xx = "" ;
        $len = 0 ;
        $s0 = 0 ;
        while(1) {
            $s1 = index($val,"/",$s0) ;
            $s2 = index($val," ",$s0) ;
            $s3 = index($val,",",$s0) ;
            if ($s1 < 0  && $s2 < 0 && $s3 < 0) {
                $v1 = substr($val,$s0) ;
                if (($len + length($v1)) <= $limit) {
                    $xx .= $v1 ;
                }
                else {
                    if ($xx ne "") {
                        push(@subs,$xx) ;
                    }
                    $xx = $v1 ;
                }
                last ;
            }
            $s1 = &little1($s1,$s2,$s3) ;
            $v1 =  substr($val,$s0,$s1-$s0+1) ;
            if (($len + length($v1)) <= $limit) {
                $xx .= $v1 ;
                $len += length($v1) ;
            }
            else {
                if ($xx ne "") {
                    push(@subs,$xx) ;
                }
                if (length($v1) > $limit)  {
                    push(@subs,$v1) ;
                    $xx = "" ;
                    $len = 0 ;
                }
                else {
                    $xx = $v1 ;
                    $len = length($v1) ;
                }
            }
            $s0 = $s1+1 ;
        }
        push(@subs,$xx) ;
        return ;
    }
    push(@subs,$val) ;
    return ;
}


# եɤȤͤץȤؿ
sub main'printfv {
    local($lev,$fd,$val) = @_ ;
    local($ii,$x,$_) ;
    local(@subs) ;
   
    if ($vlang eq "E") {
        do split_val(45,$val) ;
    }
    else {
        do split_val(60,$val) ;
    }

    for ($x = 0 ; $x <= $#subs ; $x++) {
        if ($x == 0) {
            if ($subs[$x] eq "") {
                do printfonly(1,1,$lev,$fd) ;
            }
            else {
                do printfonly(0,1,$lev,$fd) ;
            }
            printf ("%s\n",$subs[$x]) ;
        }
        else {
            do printfonly(0,0,$lev," ") ;
            printf (" %s\n",$subs[$x]) ;
        }
    }
}



# եɤץȤؿʲԤ
sub main'printfonly {
    local($retflag,$flag,$lev,$fd) = @_ ;
    local($x,$ind,$_) ;
    local(@fn) ;
    local($sepcul) = 32 ;

    if ($vlang eq "E") {
        $sepcul = 47 ;
    }
    $ind = $lev * 2 ;        #եɤΥץȥॹå
    for (  ; $lev > 0 ; $lev-- ) {
        print("  ") ;
    }

    if ($FNAME{$fd}  ne "") {#ե̾Υץ
        @fn = split(/\t/,$FNAME{$fd}) ;
        if ($vlang eq "J") {
            $fd = $fn[0] ;
        }
        else {
            $fd = $fn[1] ;
        }
    }
    if ((length($fd) + $ind + 2) >= $sepcul) {
        if ($flag == 1) {
            print("<$fd>") ;
        }
        else {
            print(" $fd") ;
        }
        if ($retflag == 1) { #Х塼ʤեɤξ
            return ;
        }
        print("\n") ;
        $ind = 0 ;
        $x = 0;
    }
    elsif ($fd =~ /\S/ ) {
        if ($flag == 1) {
            print("<$fd>") ;
        }
        else {
            print(" $fd ") ;
        }
        $x = length($fd)+2 ;
    }
    else {
        $x = 0;
    }
    # #printf("<%s>",$fd) ;
    for ( $x = $sepcul - $x - $ind ; $x > 0 ; $x-- ) {
        print(" ") ;
    }
}



#Ѹ켭ϴؿ
sub main'ewdprint {
    local( @in ) = @_ ;
    # ٥,Х塼,ե̾¸ߥե饰
    @fname = (0,1, "쥳ֹ",
              0,0, "Ф",
              1,1, "ñ츫Ф",
              1,1, "Ѳ-Ϣ°",
              1,1, "ڤ",
              1,1, "ȯ",
              0,0, "ʸˡ",
              1,1, "ʻ",
              1,1, "ʸ",
              1,1, "Ѳ",
              1,1, "ʸˡ°",
              1,1, "ʸ",
              1,1, "ǽ",
              1,1, "ǽ",
              0,0, "̣",
              1,1, "ǰ̻",
              1,0, "ǰФ",
              2,1, "Ѹ쳵ǰФ",
              2,1, "ܸ쳵ǰФ",
              1,0, "ǰ",
              2,1, "Ѹ쳵ǰ",
              2,1, "ܸ쳵ǰ",
              0,0, "ѡ¾",
              1,1, "ˡ",
              1,1, "",
              0,0, "",
              1,1, "") ;

    foreach $val (@in) {
        $ex = 0 ;
        while($ex == 0) {
            $lev = shift(@fname) ;
            $ex  = shift(@fname) ;
            $fn  = shift(@fname) ;
            if ($ex == 0) {
                do printfv($lev,$fn,"") ;
            }
        }
        if ($val ne "\"\"") {
            do printfv($lev,$fn,$val) ;
            if ($fn eq "Ѳ-Ϣ°") {
               do pick_con($val) ;
            }
            elsif ($fn eq "ʻ" || 
                   $fn eq "Ѳ" ||
                   $fn eq "ʸˡ°" ||
                   $fn eq "ʸ" ||
                   $fn eq "ǽ" ||
                   $fn eq "ǽ" ||
                   $fn eq "ˡ" ) {
               do pick_grm($val) ;
            }
        }
    }
    printf("\n") ;
}




#ϴؿ
sub main'jebprint {
    local(@aa) = @_ ;
    local($ex,$lev,$fn) ;
    # ٥,Х塼,ե̾¸ߥե饰
    @fname = (0,1, "쥳ֹ",
              0,0, "Ф",
              1,1, "ñ츫Ф",
              0,0, "ʸˡ",
              1,1, "ʻ",
              0,0, "̣",
              1,1, "ǰ̻",
              1,0, "ǰФ",
              2,1, "Ѹ쳵ǰФ",
              2,1, "ܸ쳵ǰФ",
              1,0, "ǰ",
              2,1, "Ѹ쳵ǰ",
              2,1, "ܸ쳵ǰ",
              0,1, "",
              0,0, "",
              1,1, "") ;

    foreach $val (@aa) {
        $ex = 0 ;
        while($ex == 0) {
            $lev = shift(@fname) ;
            $ex  = shift(@fname) ;
            $fn  = shift(@fname) ;
            if ($ex == 0) {
                do printfv($lev,$fn,"") ;
            }
        }
        if ($val ne "\"\"") {
            if ($fn eq "") {
                do printfv($lev,$fn,"") ;
                @ya = split(/\/\//,$val) ;
                foreach $yak1 (@ya) {
                    do yakugopr($yak1) ;
                }
            }
            else {
                do printfv($lev,$fn,$val) ;
                if ($fn eq "ʻ") {
                   do pick_grm($val) ;
                }
            }
        }
    }
    printf("\n") ;
}



sub main'yakugopr {
    local($yakugo) = @_ ;
    local($ex,$lev,$fn) ;
    # ٥,Х塼,ե̾¸ߥե饰
    @fname1 = (1,0, "",
               2,1, "",
               2,1, "ɽ",
               2,1, "ʻ") ;
    @ylist =  split(/\|/,$yakugo) ;
    foreach $y1 (@ylist) {
        $ex = 0 ;
        while($ex == 0) {
            $lev = shift(@fname1) ;
            $ex  = shift(@fname1) ;
            $fn  = shift(@fname1) ;
            if ($ex == 0) {
                do printfv($lev,$fn,"") ;
            }
        }
        if ($y1 ne "\"\"" && $y1 ne "x") {
            do printfv($lev,$fn,$y1) ;
            if ($fn eq "ʻ") {
               do pick_tran($y1) ;
            }
        }
    }
}





sub print2tab {
    local($v1) = @_ ;
    if (length($v1) >= 8) {
        printf ("%s\t",$v1) ;
    }
    else {
        printf ("%s\t\t",$v1) ;
    }
}


#ϴؿ
sub main'jccprint {
    local( @in ) = @_ ;
    local($ct,@ids) ;
    local($freq) ;
    $recid = $in[0] ;  #쥳ֹ
    $kuwd1 = $in[1] ;  #縫Фñɽ
    $kucc  = $in[2] ;  #縫Фʶطҡ
    $kuwd2 = $in[3] ;  #縫Фñɽ
    $_ = $in[4] ;
    $ct = 4 ;
    $next = $ct ;
    $_ = $in[$next] ;
    while( /\s*{.*/ ) {
        $ct = $next ;
        push(@ids,$ct) ;
        if (  $in[ $ct + 5 ] =~ /^"(.*)$/ ) {
           $next = $ct+5 ;
           $_ = $in[$next] ;
           next ;
        }
        $next = $ct+9;
        $_ = $in[$next] ;
    }
    
    $ct = $next+1 ;       # }{ƱΡɤˤ뤿ᡪ
    #ɽض
    $hyouke = $in[$ct] ;
    $hyorel = $in[$ct+1] ;
    $hyokak = $in[$ct+2] ;
    #鳵ǰ
    $gaiuke = $in[$ct+3] ;
    $gairel = $in[$ct+4] ;
    $gaikak = $in[$ct+5] ;
    #鶦
    $joukyo = $in[$ct+6] ;
    #
    $etc    = $in[$ct+7] ;

    do printfv(0,"쥳ֹ",$recid) ;
    $kumida = $kuwd1 . "/" . $kucc . "/" . $kuwd2 ;
    do printfv(0,"縫Ф",$kumida);
    do printfv(0,"ʸ", "") ;
    do printfv(1,"繽Ǿ", "") ;
    do printfonly(0,1,2,"ֹ") ;
    for ($x = 0 ; $x <= $#ids ; $x++) {
        do youso_no2($ids[$x],$ids[$x+1],@in) ;
    }
    print("\n") ;
    do printfonly(0,1,2,"ɽ") ;
    for ( $x = 0 ; $x <= $#ids ; $x++ ) {
        do print2tab($in[$ids[$x]+1]) ;
    }
    print("\n") ;
    if ( $recid =~ /^JCC/ ) {
        do printfonly(0,1,2,"ɽ") ;
    }
    else {
        do printfonly(0,1,2,"") ;
    }
    for ( $x = 0 ; $x <= $#ids ; $x++) {
        do print2tab($in[$ids[$x]+2]) ;
    }
    print("\n") ;
    do printfonly(0,1,2,"ʻ") ;
    for (  $x = 0 ; $x <= $#ids ; $x++ ) {
        do print2tab($in[$ids[$x]+3]) ;
    }
    print("\n") ;

    # #printf ("    ɽؼ¦[%s]\n",$hyouke);
    # #printf ("    ɽشط  [%s]\n",$hyorel);
    # #printf ("    ɽط¦[%s]\n",$hyokak);
    do printfv(1,"ʸط", "") ;
    do printfv(2,"¦",$hyouke) ;
    do printfv(2,"ط",$hyorel) ;
    do printfv(2,"¦",$hyokak) ;
#    do koubun_uke($hyouke) ;
#    do koubun_rel($hyorel) ;
#    do koubun_kak($hyokak) ;

    # #printf ("    ̣\n") ;
    if ( $gairel ne "\"\"") {
        do printfv(0,"̣","");
        do printfv(1,"ǰ","");
        $x = index($gaiuke,"/",0) ;
        $_ = substr($gaiuke,0,$x) ;
        s/\s//g ;
        do printfv(2,"ֹ",$_) ;
        $x = 0 ;
        $id = -1 ;
        while($x <= $#ids && $id == -1) {
            if ( &match_id($_,$in[$ids[$x]]) ) {
                $id = $x ;
            }
            $x++;
        }
        do imi_shiten($ids[$id],@in);
    } 
    if ( $gairel ne "\"\"") {
        do printfv(1,"ǰط",$gairel);
    }
    if ( $gaiuke ne "\"\"") {
        do printfv(1,"ǰ","");
        $x = index($gaikak,"/",0) ;
        $_ = substr($gaikak,0,$x) ;
        s/\s//g ;
        do printfv(2,"ֹ",$_) ;
        $x = 0 ;
        $id = -1 ;
        while($x <= $#ids && $id == -1) {
            if ( &match_id($_,$in[$ids[$x]]) ) {
                $id = $x ;
            }
            $x++;
        }
        do imi_shiten($ids[$id],@in);
    }

    # #printf ("        [%s]\n",$joukyo) ;
    $x = index($joukyo,";",0) ;  
    $hkhindo = substr($joukyo,0,$x) ;
    $pos = $x + 1;
    $x = index($joukyo,";",$pos) ;
    $kkhindo = substr($joukyo,$pos,$x-$pos) ;
    $pos = $x + 1;
    $x = index($joukyo,";",$pos) ;
    $ukyhindo = substr($joukyo,$pos,$x-$pos) ;
    $pos = $x + 1;
    $x = index($joukyo,";",$pos) ;
    $kkyhindo = substr($joukyo,$pos,$x-$pos) ;
    $pos = $x + 1;
    do printfv(0,"", "") ;
    $freq = $hkhindo.";".$kkhindo.";".$ukyhindo.";".$kkyhindo ;
    do printfv(1,"", $freq) ;
#    do printfv(2,"ɽض", $hkhindo) ;
#    do printfv(2,"", $kkhindo) ;
#    do printfv(2,"", "" ) ;
#    do printfv(3,"¦", $ukyhindo ) ;
#    do printfv(3,"¦", $kkyhindo ) ;
    @ex = split(/}/,substr($joukyo,$pos)) ;
    foreach $ex1 (@ex) {
        $x = index($ex1,"{",0) ;
        substr($ex1,0,$x+1) = "" ;
        do printfv(1,"ʸ",$ex1) ;
    }
    # #print ("-------------------------------------------------\n");
    # #do printfv(0,"","") ;
    # #do printfv(1,"",$etc) ;
    printf("\n") ;
}



sub main'kokka {
    local($id,@ff) = @_;
    $_ = @ff[$id] ;
    while(  !/.*}.*/ ) {
        # #printf ("kokka) %d [%s]\n",$id,@ff[$id]) ;
        $id++;
        $_ = @ff[$id] ;
    }
    ##printf ("kokka)END %d => %s\n",$id,@ff[$id]);
    return $id ;
}


sub main'youso_no2 {
    local($st,$end,@ff) = @_ ;
    local($x,$_) ;
    $x = index($ff[$st],"{",0) ;
    $_ = substr($ff[$st],$x+1) ;
    s/^\s*// ;
    printf ("%s\t\t",$_)    ;
}


sub main'youso_no {
    local($st,$end,@ff) = @_ ;
    local($x,$_) ;
    $x = index($ff[$st],"{",0) ;
    $_ = substr($ff[$st],$x+1) ;
    s/^\s*// ;
    printf ("%s\t",$_)    ;
}

sub main'koubun_uke {
    local($uke) = @_ ;
    local($x,$ss) ;
    $x = index($uke,"/",0) ;
    do printfv(2,"¦ֹ",substr($uke,0,$x)) ;
    do printfv(2,"¦ɽ",substr($uke,$x+1)) ;
}


sub main'koubun_rel {
    local($uke) = @_ ;
    local($x,$ss) ;
    $x = index($uke,"/",0) ;
    do printfv(2,"طֹ",substr($uke,0,$x)) ;
    $ss = index($uke,"/",$x+1) ;
    do printfv(2,"ط",substr($uke,$x+1,$ss-$x-1)) ;
}


sub main'koubun_kak {
    local($uke) = @_ ;
    local($x,$ss) ;
    $x = index($uke,"/",0) ;
    do printfv(2,"¦ֹ",substr($uke,0,$x)) ;
    do printfv(2,"¦ɽ",substr($uke,$x+1)) ;
}


sub main'match_id {
    local($id,$st_char) = @_ ;
    local($ss,$_,@num) ;
    $ss = index($st_char,"{",0) ;
    $_ = substr($st_char,$ss+1) ;
    s/^\s*// ;
    # #printf ("%s\t",$_)    ;
    @num = split(/,/,$_) ;
    if (grep (/^$id$/,@num)) {
        return 1 ;
    }
    return 0 ;
}    


sub main'imi_shiten {
    local($id,@all) = @_ ;
    local($x) ;
    # #do printfv(2,"Ѷե饰ʷбط",@all[$id+4]) ;
    $_ = @all[$id+5] ;
    if ( /^\"/ ) {
        if ( /^\"\"/ ) {
            # #printf ("  >>>>>>>>>>>>>>>>> ̣ʤ\n") ;
        }
        else {
            $x = index(@all[$id+5],"}",0) ;
            do printfv(2,"ʣ糵ǰ",substr(@all[$id+5],0,$x)) ;
        }
    }
    else {
        $x = index(@all[$id+5],"}",0) ;
        if ($x < 0) {
            do printfv(2,"ǰ̻",@all[$id+5]) ;
        }
        else {
            do printfv(2,"ǰ̻",substr(@all[$id+5],0,$x)) ;
        }
        if (@all[$id+6] ne "\"\"" && @all[$id+7] ne "\"\"") {
            do printfv(2,"ǰФ","") ;
            if (@all[$id+6] ne "\"\"") {
                do printfv(3,"Ѹ쳵ǰФ",@all[$id+6]) ;
            }
            if (@all[$id+7] ne "\"\"") {
                do printfv(3,"ܸ쳵ǰФ",@all[$id+7]) ;
            }
        }
        if (@all[$id+8] ne "\"\"" && substr(@all[$id+9],0,$x) ne "\"\"") {
            do printfv(2,"ǰ","") ;
            if (@all[$id+8] ne "\"\"") {
                do printfv(3,"Ѹ쳵ǰ",@all[$id+8]);
            }
            $x = index(@all[$id+9],"}",0) ;
            if (substr(@all[$id+9],0,$x) ne "\"\"") {
                do printfv(3,"ܸ쳵ǰ",substr(@all[$id+9],0,$x));
            }
        }
    }
}






#ܸư춦ѥϴؿ
sub main'jccptprint {
    local( @in ) = @_ ;
    local($ct,@ids,@ids2,@ids3) ;
    local($ix,$t);
    local(@rel1) ;
    do printfv(0,"쥳ֹ",$in[0]) ;
    do printfv(0,"ʸѥ󸫽Ф",$in[1]);
    $ct = 2 ;
    $next = $ct ;
    $_ = $in[$next] ;
    while( /^[0-9]+$/ ) {
        $ct = $next ;
        push(@ids,$ct) ;
        $next = $ct + 5 ;
        $_ = $in[$next] ;
    }
    
    $reibun = $in[$next] ;
    $ct = $next+1  ;
    $next = $ct ;
    $_ = $in[$next] ;
    while( !/^}\s*/ ) {
        $ct = $next ;
        push(@ids2,$ct) ;
        $next = $ct + 2 ;
        $_ = $in[$next] ;
    }
    $ct = $next+1 ;
    $next = $ct ;
    $_ = $in[$next] ;
    while( !/.*\s*/ ) {
        $ct = $next ;
        push(@ids3,$ct) ;
        $next = $ct + 3 ;
        $_ = $in[$next] ;
    }
    $next++ ;
    $etc = $in[$next] ;

    do printfv(0,"ʸǾ", "") ;
    do printfv(1,"ʸѥ", "") ;
    do printfonly(0,1,2,"ֹ") ;
    for ( $x = 0 ; $x <= $#ids ; $x++) {
        do youso_no($ids[$x],$ids[$x+1],@in) ;
    }
    print("\n") ;
    do printfonly(0,1,2,"") ;
    for ( $x = 0 ; $x <= $#ids ; $x++ ) {
        printf ("%s\t",$in[$ids[$x]+1]) ;
    }
    print("\n") ;
    do printfonly(0,1,2,"ʸˡ") ;
    for ( $x = 0 ; $x <= $#ids ; $x++ ) {
        if ( $in[$ids[$x]+2] eq "\"\"") {
            print ("\t") ;
        }
        else {
            printf ("%s\t",$in[$ids[$x]+2]) ;
        }
    }
    print("\n") ;
    do printfonly(0,1,2,"ǰ̣") ;
    for ( $x = 0 ; $x <= $#ids ; $x++ ) {
        if ( $in[$ids[$x]+3] eq "\"\"") {
            print ("\t") ;
        }
        else {
            printf ("%s\t",$in[$ids[$x]+3]) ;
        }
    }
    print("\n") ;
    do printfonly(0,1,2,"  ") ;
    for ( $x = 0 ; $x <= $#ids ; $x++) {
        if ($in[$ids[$x]+4] eq "\"\"") {
            print ("\t") ;
        }
        else {
            printf ("%s\t",$in[$ids[$x]+4]) ;
        }
    }
    print("\n") ;
    do printfv(0,"ʸ", $reibun) ;

    do printfv(0,"ʸ", "") ;
    do printfv(1,"ʸ", "") ;
    do printfonly(0,1,2,"ǰط") ;
    for ( $x = 0 ; $x <= $#ids2 ; $x++) {
        $_ = $in[$ids2[$x]] ;
        s/^\s*{\s*// ;
        printf ("%s\t",$_) ;
    }
    print("\n") ;
    do printfonly(0,1,2,"ʽ") ;
    for ( $x = 0 ; $x <= $#ids2 ; $x++) {
        printf ("%s\t",$in[$ids2[$x]+1]) ;
    }
    print("\n") ;

    do printfv(0,"̣", "") ;
    do printfv(1,"̣", "") ;
    do printfonly(0,1,2,"ǰط") ;

    for ( $x = 0 ; $x <= $#ids3 ;  $x++ ) {
        $_ = $in[$ids3[$x]] ;
        s/^\s*\s*// ;
        printf ("%s\t",$_) ;
    }
    print("\n") ;
    $ix = 0 ;
    do {
        $t = 0 ;
        if ($ix == 0) {
            do printfonly(0,1,2,"ǰ̻ҡ") ;
        }
        else {
            do printfonly(0,1,2,"") ;
        }
        for($x = 0 ; $x <= $#ids3 ; $x++) {
            @rel1 = split(/;/,$in[$ids3[$x]+1]) ;
            if ($ix > $#rel1) {
                print ("\t") ;
            }
            else {            
                $t++ ;
                print ("$rel1[$ix]\t") ;
            }
        }
        print("\n") ;
        $ix++ ;
    } while ($t != 0) ;
    for ( $x = 0 ; $x <= $#ids3 ; $x++) {
        if ($x == 0) {
            $_ = "" ;
            do printfv(1,"ǰ",$in[$ids3[$x]+2]) ;
        }
        else {
            $_ = "\t".$_ ;
            $t = $_.$in[$ids3[$x]+2] ;
            do printfv(1,"",$t) ;
        }
    }
    # #print ("-------------------------------------------------\n");
    do printfv(0,"","") ;
    do printfv(1,"",$etc) ;
    printf("\n") ;
}







#ܸ쥳ѥϴؿ
sub main'jcorpprint {
    local( @in ) = @_ ;
    local($ct,@ids,@ids2,@ids3) ;
    local($ix,$t);
    local(@rel1) ;

    do printfv(0,"쥳ֹ",$in[0]) ;
    do printfv(0,"ʸ","") ;
    do printfv(1,"ƥֹ",$in[1]);
    do printfv(1,"ŵ",$in[2]);
    do printfv(1,"ʸ",$in[3]);
    do printfv(0,"ʸǾ","ֹ ɽ  ɽ  ʻ  ǰ") ;

    $ct = 5 ;    # { 򥹥åפ롣
    $_ = $in[$ct] ;
    while( !/^\}/ ) {
        print("\t$in[$ct]\t$in[$ct+1]\t$in[$ct+2]\t$in[$ct+3]\t$in[$ct+4]\n") ;
        $ct += 5 ;
        $_ = $in[$ct] ;
        # #printf ("  next=%d ct=%d\n",$next,$ct) ;
    }
    # #printf ("\n============>  next=%d ct=%d\n",$next,$ct) ;
    $ct++ ;
    do printfv(0,"Ǿ","") ;
    do print_mor_inf($in[$ct]) ;
    $ct++ ;
    do printfv(0,"ʸ","") ;
    do syntacpp("SYN",$in[$ct]) ;
    do printfv(0,"̣","") ;
    do syntacpp("SEM",$in[$ct+1]) ;
    do printfv(0,"","") ;
    do printfv(1,"",$in[$ct+2]) ;
    printf("\n") ;
}



#Ǿ
sub main'print_mor_inf {
    local($in) = @_ ;
    local(@node,$ct) ;
    local($s1,$m1) ;
    @node = split(/\//,$in) ;
    # 
    print ("\t") ;
    for ($ct = 0 ; $ct <= $#node ; $ct++ ) {
        # ##printf ("Cur_Morph(%d) [%s]\n",$ct,$node[$ct]) ;
        if ( $node[$ct] eq "") {
            next ;
        }
        if( $node[$ct] =~ /^[0-9]+:/ ) {
            $s1 = index($node[$ct],":",0) ;
            $m1 = substr($node[$ct],$s1+1) ;
            print ("/$m1") ;
        }
        else {
            last ;
        }
    }
    print ("/\n") ;
    # ʣ첽
    for ( ; $ct <= $#node ; $ct++ ) {
        if( $node[$ct] =~ /^\}$/) {
           last ;
        }
        $_ = @node[$ct] ;
        s/^\s*{\s*// ;
        print ("\t$_\t:") ;
        $ct++ ;
        if ($node[$ct] ne "") {
            print STDERR ("FormatError! CC(1)\n") ;
            return ;
        }
        $ct++ ;
        for ( ; $ct <= $#node ; $ct++ ) {
            if( $node[$ct] =~ /^[0-9]+:/ ) {
                $s1 = index($node[$ct],":",0) ;
                $m1 = substr($node[$ct],$s1+1) ;
                print ("/$m1") ;
            }
            elsif ($node[$ct] eq "\*") {
                print ("\"\"\n") ;
            }
        }
        print("/\n") ;
    }

}



sub main'split_syn_sex {
    local($sex) = @_ ;
    local(@ans,@wk) ;
    local($idx,$nd1) ;

    @wk = split(/\(/,$sex) ;
    $idx = 0 ;
    for ($ct = 1 ; $ct <= $#wk ; ) {
        if ($idx == $#wk) {
            push(@ans,$wk["(".$ct]) ;
            last ;
        }
        $nd1 = $wk[$ct] ;
        for ($cts = $ct+1 ; $cts <= $#wk ; $cts++) {
            if ( $wk[$cts] =~ /^[StMWIN]/ ) {
                last ;
            }
            $nd1 .= $wk[$cts] ;
        }
        $ct = $cts ;
        push(@ans,"(".$nd1) ;
    }
    return @ans ;    
}




sub main'split_sem_sex {
    local($sex) = @_ ;
    local(@ans,@wk) ;
    local($idx,$nd1) ;

    @wk = split(/\[/,$sex) ;
    $idx = 0 ;
    for ($ct = 1 ; $ct <= $#wk ; ) {
        if ($idx == $#wk) {
            push(@ans,$wk["[".$ct]) ;
            last ;
        }
        $nd1 = $wk[$ct] ;
#        for ($cts = $ct+1 ; $cts <= $#wk ; $cts++) {
#            if ( $wk[$cts] =~ /^[StMWI]/ ) {
#                last ;
#            }
#            $nd1 .= $wk[$cts] ;
#        }
#        $ct = $cts ;
        push(@ans,"[".$nd1) ;
        $ct++ ;
    }
    return @ans ;    
}



#ʸ(Ӽץƥץ)
sub main'syntacpp {
    local($flag,$in) = @_ ;
    local($ct,$lev,$ss,$kokka) ;
    local(@cul) ;
    local(@node) ;

    if ( $flag eq "SYN" ) {
        @node = do split_syn_sex($in) ;
    }
    elsif ( $flag eq "SEM") {
        @node = do split_sem_sex($in) ; ;
    }
    $lev = 0 ;
    @cul[$lev] = 0 ;
    for ($ct = 0 ; $ct <= $#node ; ) {
        if ( $node[$ct] eq "") {
            $ct++ ;
            next ;
        }
        # #printf ("Cur_NODE [%s]\n", @node[$ct]) ;
        if (( $flag eq "SYN" && $node[$ct] =~ /.*\)+\s*$/) ||
            ( $flag eq "SEM" && $node[$ct] =~ /.*\]+\s*$/) ) {
            print (" $node[$ct]") ;
            $kokka = &kokka_count($flag,$node[$ct]) ;
            $lev -= $kokka ;
            if ($lev < 0) {
                $lev = 0 ;
            }
            # #print ("kokka=$kokka  lev=$lev\n");
            for ($ct++ ;  $ct <= $#node ; $ct++) {
                if ( $node[$ct] ne "") {
                    last ;
                }
            }
            if ($ct > $#node) {
                last ;    
            }
            # #print ("-----------> [$node[$ct]]\n") ;
            if ( ($flag eq "SYN" && $node[$ct] =~ /^\s*\(.*$/ ) ||
                     ($flag eq "SEM" && $node[$ct] =~ /^\s*\[.*$/ )) {
                print ("\n") ;
                # #print ("               lev=$lev cul[$lev] = $cul[$lev]\n");
                for ($ss = 0 ; $ss < $cul[$lev] ; $ss++) {
                    print (" ") ;
                }
                next ;
            }
      # #print (" [$node[$ct]]  ( ̵!!!!!\n") ;
            next ;
        }
        if ( ($flag eq "SYN" && $node[$ct] =~ /^\s*\(.*/ ) ||
             ($flag eq "SEM" && $node[$ct] =~ /^\s*\[.*/ )) {
      # #print ("     (\n") ;
            print (" $node[$ct]") ;
            $cul[$lev+1] = $cul[$lev] + length($node[$ct])+1 ;
            # #printf ("               lev=%d  len=%d\n",$lev,length($node[$ct]));
            $lev++ ;
            $ct++ ;
            next ;
        }
        else {
            print (" $node[$ct]") ;
        }
        $ct++ ;
    }
    print ("\n") ;
}




#Ĥ̤οؿ
sub main'kokka_count {
    local($flag,$in) = @_ ;
    local(@s) ;
    local($ct,$x) ;
    @s = split(//,$in);
    $ct = 0 ;
    foreach $x (@s) {
        if ( ($flag eq "SYN" &&  $x eq ")" ) ||
             ($flag eq "SEM" &&  $x eq "]" ) ) {
            $ct++ ;
        }
        elsif ( ($flag eq "SYN" && $x eq "(" ) ||
                ($flag eq "SEM" && $x eq "[" ) ) {
            $ct-- ;
        }
    }
    return $ct ;
}




#ꤵ줿ʸǥѥ졼
sub main'sep1 {
    local($sep,$in) = @_ ;
    local(@s, @st) ;
    local($ct,$x) ;
    local($flag) ;
    
    @st = split("",$in);
    @s = () ;
    $wk = "" ;
    $flag = 1 ;
    for( $ii = 0 ; $ii <= $#st ; $ii++ ) {
        if ( $st[$ii] eq "\\" ) {
            $wk .= $st[$ii] ;
            $ii++;
            $wk .= $st[$ii] ;
        }
        if ( $st[$ii] eq "\"" ) {
            $flag *= (-1) ;
        }
        if ( $flag < 0 ) {
            $wk .= $st[$ii] ;
            next ;
        }
        if ( $sep eq $st[$ii]  ) {
            push( @s, $wk ) ;
            $wk = "" ;
        }
        else {
           $wk .= $st[$ii] ;
        }
    }
    push( @s, $wk ) ;
    return @s ;
}




#ǰФϴؿ
sub main'cphprint {
    local( @in ) = @_ ;
    # ٥,Х塼,ե̾¸ߥե饰
    @fname = (0,1, "쥳ֹ",
              0,1, "ǰ̻",
              0,0, "ǰФ",
              1,1, "Ѹ쳵ǰФ",
              1,1, "ܸ쳵ǰФ",
              0,0, "ǰ",
              1,1, "Ѹ쳵ǰ",
              1,1, "ܸ쳵ǰ",
              0,0, "",
              1,1, "") ;

    foreach $val (@in) {
        $ex = 0 ;
        while($ex == 0) {
            $lev = shift(@fname) ;
            $ex  = shift(@fname) ;
            $fn  = shift(@fname) ;
            if ($ex == 0) {
                do printfv($lev,$fn,"") ;
            }
        }
        if ($val ne "\"\"") {
            do printfv($lev,$fn,$val) ;
        }
    }
    printf("\n") ;
}



#ǰηϽϴؿ
sub main'cpcprint {
    local( @in ) = @_ ;
    # ٥,Х塼,ե̾¸ߥե饰
    @fname = (0,1, "쥳ֹ",
              0,1, "̳ǰ̻",
              0,1, "̳ǰ̻",
              0,0, "",
              1,1, "") ;

    foreach $val (@in) {
        $ex = 0 ;
        while($ex == 0) {
            $lev = shift(@fname) ;
            $ex  = shift(@fname) ;
            $fn  = shift(@fname) ;
            if ($ex == 0) {
                do printfv($lev,$fn,"") ;
            }
        }
        if ($val ne "\"\"") {
            do printfv($lev,$fn,$val) ;
        }
    }
    printf("\n") ;
}





#ǰҽϴؿ
sub main'cptprint {
    local( @in ) = @_ ;
    # ٥,Х塼,ե̾¸ߥե饰
    @fname = (0,1, "쥳ֹ",
              0,1, "Ҷʬ",
              0,0, "ҥץ",
              1,1, "ǰ̻ң",
              1,1, "ط",
              1,1, "ǰ̻ң",
              1,1, "",
              0,0, "",
              1,1, "") ;

    foreach $val (@in) {
        $ex = 0 ;
        while($ex == 0) {
            $lev = shift(@fname) ;
            $ex  = shift(@fname) ;
            $fn  = shift(@fname) ;
            if ($ex == 0) {
                do printfv($lev,$fn,"") ;
            }
        }
        if ($val ne "\"\"") {
            do printfv($lev,$fn,$val) ;
        }
    }
    printf("\n") ;
}





#Ѹ춦ϴؿ
sub main'tjccprint {
    local (@aa) = @_ ;
    # ٥,Х塼,ե̾¸ߥե饰
    @fname = (0,1, "쥳ֹ",
              0,1, "̾ñ",
              0,0, "̣",
              1,1, "ǰ̻",
              1,0, "ǰФ",
              2,1, "Ѹ쳵ǰФ",
              2,1, "ܸ쳵ǰФ",
              1,0, "ǰ",
              2,1, "Ѹ쳵ǰ",
              2,1, "ܸ쳵ǰ",
              1,1, "ɽس",
              0,1, "ưñ",
              0,0, "̣",
              1,1, "ǰ̻",
              1,0, "ǰФ",
              2,1, "Ѹ쳵ǰФ",
              2,1, "ܸ쳵ǰФ",
              1,0, "ǰ",
              2,1, "Ѹ쳵ǰ",
              2,1, "ܸ쳵ǰ",
              0,1, "س",
              0,0, "",
              1,1, "") ;

    foreach $val (@aa) {
        $ex = 0 ;
        while($ex == 0) {
            $lev = shift(@fname) ;
            $ex  = shift(@fname) ;
            $fn  = shift(@fname) ;
            if ($ex == 0) {
                do printfv($lev,$fn,"") ;
            }
        }
        if ($val ne "\"\"") {
            do printfv($lev,$fn,$val) ;
        }
    }
    printf("\n") ;
}


sub main'print_symtbl1 {
    local( @in ) = @_ ;
    local($lev,$ex,$fn,$att) ;
    local(%vv) ;
    local($len,$ct,$xx) ;
    local(@subs) ;
    local(@vje) ;
    %vv = () ;
    while($#in >= 0) {
        $lev = shift(@in) ;
        $ex  = shift(@in) ;
        $fn  = shift(@in) ;
        if ($vv{$fn} ne "") {
            next ;
        }
        $vv{$fn} = 1 ;
        $att = $ATTR{$lev} ;
        if ($att eq "") {
            $att = $lev ;
        }
        do printfonly(0,0,1,$att) ;
        printf ("%s ",$ex) ;

        @vje = () ;
        @vje = split(/\t/,$fn);
        
        if ($vlang eq "J") {
            $fn = $vje[0] ;
            do split_symtblval($fn) ;
        }
        else {
            $fn = $vje[$#vje] ;
            if ($vlang eq "E") {
                do split_val(35,$fn) ;
            }
            else {
                do split_val(50,$fn) ;
            }
        }

        $len = length($ex) ;
        for ($ct=0 ; $ct <= $#subs ; $ct++) {
            if ($ct == 0) {
                for ($xx = 5 - $len  ; $xx > 0 ; $xx--) {
                    printf (" ") ;
                }
                printf ("... %s\n",$subs[$ct]) ;
            }
            else {
                do printfonly(0,0,1," ") ;
                for ($xx = 5 - $len  ; $xx > 0 ; $xx--) {
                    printf (" ") ;
                }
                printf ("         %s\n",$subs[$ct]) ;
            }
        }
    }
}



# Х塼ŬĹʬ䤹롣
sub main'split_symtblval {
    local($val) = @_ ;
    local($xx,$s1,$s2,$len) ;
    local($limit) = 50 ;
    @subs = () ;
    if (length($val) <= $limit) {
        push(@subs,$val) ;
        return ;
    }
    if ($val =~ "" || $val =~ "") {
        $xx = "" ;
        $len = 0 ;
        $s0 = 0 ;
        while(1) {
            $s1 = index($val,"",$s0) ;
            $s2 = index($val,"",$s0) ;
            if ($s1 < 0  && $s2 < 0) {
                $v1 = substr($val,$s0) ;
                if (($len + length($v1)) <= $limit) {
                    $xx .= $v1 ;
                }
                else {
                    if ($xx ne "") {
                        push(@subs,$xx) ;
                    }
                    $xx = $v1 ;
                }
                last ;
            }
            if ($s1 < 0) {
                $s1 = $s2 ;
            }
            elsif ($s2 < 0) {
                ;
            }
            elsif ($s1 > $s2) {
                $s1 = $s2 ;
            }
            $v1 =  substr($val,$s0,$s1-$s0+2) ;
            if (($len + length($v1)) <= $limit) {
                $xx .= $v1 ;
                $len += length($v1) ;
            }
            else {
                if ($xx ne "") {
                    push(@subs,$xx) ;
                }
                if (length($v1) > $limit)  {
                    push(@subs,$v1) ;
                    $xx = "" ;
                    $len = 0 ;
                }
                else {
                    $xx = $v1 ;
                    $len = length($v1) ;
                }
            }
            $s0 = $s1+2 ;
        }
        push(@subs,$xx) ;
        return ;
    }
    push(@subs,$val) ;
    return ;
}




#ܺ
sub main'print_symtbl {
    do print_symtbl1(@lcontbl) ;
    do print_symtbl1(@rcontbl) ;
    do print_symtbl1(@symtbl) ;
    printf("\n") ;
}

